package logicland2;

import java.awt.Color;
import java.awt.Graphics;

import logicland2.block.Block;
import logicland2.block.Wire;

public class AutoStraight implements Brushable {

private static Color color = new Color(0, 0, 0);
	
	int direction;

	public AutoStraight(int inputDirection) {
		direction = inputDirection;
	}
	
	@Override
	public boolean addToWorld(World world, Pos pos) {
		Block tempBlock = world.getBlock(pos);
		if (tempBlock instanceof Wire) {
			Wire tempWire1 = (Wire)tempBlock;
			int tempDirection1 = tempWire1.getDirection();
			if (tempDirection1 == 11) {
				return false;
			}
			int tempDirection2 = direction;
			if (tempDirection1 == 0) {
				if (direction == 1) {
					tempDirection2 = 11;
				}
			}
			if (tempDirection1 == 1) {
				if (direction == 0) {
					tempDirection2 = 11;
				}
			}
			Wire tempWire2 = new Wire(tempDirection2);
			tempWire2.addToWorld(world, pos);
			return (tempDirection1 != tempDirection2);
		} else {
			Wire tempWire = new Wire(direction);
			tempWire.addToWorld(world, pos);
			return true;
		}
	}

	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		Pos tempPos = pos.copy();
		tempPos.subtract(panel.getCameraPos());
		tempPos.scale(panel.getZoom());
		if (panel.getZoom() >= 8.0) {
			int tempWhich = 16 + direction;
			panel.drawSprite(graphics, tempPos, tempWhich);
		} else {
			graphics.setColor(color);
			int tempSize = (int)(panel.getZoom());
			if (tempSize < 1) {
				tempSize = 1;
			}
			graphics.fillRect(tempPos.getX(), tempPos.getY(), tempSize, tempSize);
		}
	}

	@Override
	public Brushable getNextVariation() {
		direction += 1;
		if (direction > 1) {
			direction = 0;
		}
		return this;
	}

	@Override
	public Brushable getPreviousVariation() {
		direction -= 1;
		if (direction < 0) {
			direction = 1;
		}
		return this;
	}
	
	@Override
	public boolean canOverlapBlock() {
		return false;
	}
	
}
