package logicland2;

import java.awt.Color;
import java.awt.Graphics;

import logicland2.block.Block;
import logicland2.block.Wire;

public class AutoWire implements Brushable {

	private static Color color = new Color(0, 0, 0);
	
	public AutoWire() {
		// Do nothing.
	}
	
	@Override
	public boolean addToWorld(World world, Pos pos) {
		Block tempBlock1 = world.getBlock(pos);
		Wire tempWire = new Wire(11);
		tempWire.addToWorld(world, pos);
		world.updateWireConnections(pos);
		Block tempBlock2 = world.getBlock(pos);
		boolean hasChangedBlock = (tempBlock2.shouldPaintOver(tempBlock1));
		int tempSide = 0;
		while (tempSide <= 3) {
			Pos tempPos = World.getPosOnSide(pos, tempSide);
			if (world.updateWireConnections(tempPos)) {
				hasChangedBlock = true;
			}
			tempSide += 1;
		}
		return hasChangedBlock;
	}

	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		Pos tempPos = pos.copy();
		tempPos.subtract(panel.getCameraPos());
		tempPos.scale(panel.getZoom());
		if (panel.getZoom() >= 8.0) {
			panel.drawSprite(graphics, tempPos, 2);
		} else {
			graphics.setColor(color);
			int tempSize = (int)(panel.getZoom());
			if (tempSize < 1) {
				tempSize = 1;
			}
			graphics.fillRect(tempPos.getX(), tempPos.getY(), tempSize, tempSize);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return this;
	}

	@Override
	public Brushable getPreviousVariation() {
		return this;
	}
	
	@Override
	public boolean canOverlapBlock() {
		return false;
	}
	
}
