package logicland2;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class Button {

	public static int height = 28;
	
	private Pos pos;
	private String text;
	private int width;
	private Color backgroundColor = new Color(192, 192, 192);
	private Color textColor = new Color(0, 0, 0);
	private Font textFont = new Font("Verdana", Font.PLAIN, 16);
	private ActionListener actionListener = null;
	
	public Button(Pos inputPos, String inputText, int inputWidth) {
		pos = inputPos;
		text = inputText;
		width = inputWidth;
	}
	
	public void setActionListener(ActionListener listener) {
		actionListener = listener;
	}
	
	public void setText(String inputText) {
		text = inputText;
	}
	
	public Pos getPos() {
		return pos;
	}
	
	public int getWidth() {
		return width;
	}
	
	public int getHeight() {
		return height;
	}
	
	public void setBackgroundColor(Color color) {
		backgroundColor = color;
	}
	
	public void setTextColor(Color color) {
		textColor = color;
	}
	
	public void draw(Graphics graphics) {
		graphics.setColor(backgroundColor);
		graphics.fillRect(pos.getX(), pos.getY(), width, height);
		graphics.setFont(textFont);
		graphics.setColor(textColor);
		graphics.drawString(text, pos.getX() + 6, pos.getY() + 20);
	}
	
	public void press() {
		actionListener.actionPerformed(new ActionEvent(this, -1, "press"));
	}
	
}
