package logicland2;

import java.awt.Color;
import java.awt.Graphics;

public class Marker implements Brushable {

	private static Color color1 = new Color(0, 255, 0);
	private static Color color2 = new Color(0, 192, 192);
	
	private int id;
	private Pos pos;
	
	public Marker(int inputId) {
		id = inputId;
	}
	
	@Override
	public boolean addToWorld(World world, Pos inputPos) {
		Marker tempMarker = world.getMarker(id);
		if (tempMarker != null) {
			if (tempMarker.getPos().equals(inputPos)) {
				return false;
			}
		}
		pos = inputPos.copy();
		world.addMarker(this);
		return true;
	}

	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		Pos tempPos = pos.copy();
		tempPos.subtract(panel.getCameraPos());
		tempPos.scale(panel.getZoom());
		if (panel.getZoom() >= 8.0) {
			panel.drawSprite(graphics, tempPos, id - 1);
		} else {
			if (id == 1) {
				graphics.setColor(color1);
			}
			if (id == 2) {
				graphics.setColor(color2);
			}
			int tempSize = (int)(panel.getZoom());
			if (tempSize < 1) {
				tempSize = 1;
			}
			graphics.fillRect(tempPos.getX(), tempPos.getY(), tempSize, tempSize);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return this;
	}

	@Override
	public Brushable getPreviousVariation() {
		return this;
	}
	
	public int getId() {
		return id;
	}
	
	public Pos getPos() {
		return pos;
	}
	
	@Override
	public boolean canOverlapBlock() {
		return true;
	}

}
