package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class AdditionLogicModule extends BaseLogicModule {

	@Override
	public Block copy() {
		Block output = new AdditionLogicModule();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 185);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new ExtensionLogicModule();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new FlipFlopLogicModule();
	}
	
	@Override
	public void receiveUpdate(LogicInput block) {
		int tempCount = getModuleCore().getActiveDataLogicInputCount();
		getModuleCore().setData((tempCount % 2) == 1);
		getModuleCore().setCarryData((tempCount % 4) > 1);
	}
	
}
