package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class AndLogicModule extends BaseLogicModule {

	@Override
	public Block copy() {
		Block output = new AndLogicModule();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 183);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new XorLogicModule();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new OrLogicModule();
	}
	
	@Override
	public void receiveUpdate(LogicInput block) {
		int tempCount1 = getModuleCore().getDataLogicInputCount();
		int tempCount2 = getModuleCore().getActiveDataLogicInputCount();
		getModuleCore().setData(tempCount1 == tempCount2);
	}
	
}
