package logicland2.block;

import java.util.List;

import logicland2.Pos;
import logicland2.World;

public abstract class BaseLogicModule extends LogicModule implements BaseModuleBlock {

	private ModuleCore moduleCore;
	
	public BaseLogicModule() {
		super();
		moduleCore = new ModuleCore();
		moduleCore.addBlock(this);
	}
	
	@Override
	public ModuleCore getModuleCore() {
		return moduleCore;
	}
	
	@Override
	public ModuleConnectableBlock getBlock() {
		return this;
	}
	
	@Override
	public boolean updateConnection(World world, Pos pos) {
		return false;
	}
	
	@Override
	public BaseModuleBlock getBaseModuleBlock() {
		return this;
	}
	
	@Override
	public void receiveUpdate(LogicInput block) {
		// This stub is technically unnecessary.
	}
	
	@Override
	public void populateCopy(Block block) {
		BaseLogicModule tempBlock = (BaseLogicModule)block;
		moduleCore.populateCopyData(tempBlock.getModuleCore());
	}
	
	@Override
	public void addSaveDataToList(List<Integer> list) {
		list.add(getModuleCore().getSaveData());
	}
	
	@Override
	public void setSaveDataFromList(List<Integer> list, int offset) {
		int tempNumber = list.get(offset + 0);
		getModuleCore().setSaveData(tempNumber);
	}
	
}
