package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class ButtonInputPeripheral extends BaseInputPeripheral {

	@Override
	public Block copy() {
		Block output = new ButtonInputPeripheral();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 155);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new ClockInputPeripheral();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new SwitchInputPeripheral();
	}
	
	@Override
	public void interact() {
		getModuleCore().setData(true);
	}
	
	@Override
	public void stopInteraction() {
		getModuleCore().setData(false);
	}
	
}
