package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;
import logicland2.World;

public class ClockInputPeripheral extends BaseInputPeripheral implements TickableBlock {
	
	public void addEvent(World world, Pos inputPos) {
		world.registerTickableBlock(this);
		super.addEvent(world, inputPos);
	}
	
	public void removeEvent(World world, Pos inputPos) {
		world.deregisterTickableBlock(this);
		super.addEvent(world, inputPos);
	}
	
	@Override
	public Block copy() {
		Block output = new ClockInputPeripheral();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 156);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new ExtensionInputPeripheral();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new ButtonInputPeripheral();
	}

	@Override
	public void tick(World world) {
		getModuleCore().setData(world.getClockState());
	}
	
}
