package logicland2.block;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import logicland2.Brushable;
import logicland2.Pos;
import logicland2.World;

public class ExtensionInputPeripheral extends InputPeripheral {
	
	@Override
	public Block copy() {
		Block output = new ExtensionInputPeripheral();
		populateCopy(output);
		return output;
	}

	@Override
	public Brushable getNextVariation() {
		return new LightOutputPeripheral();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new ClockInputPeripheral();
	}
	
	@Override
	public void interact() {
		if (getBaseModuleBlock() != null) {
			Block tempBase = getBaseModuleBlock().getBlock();
			if (tempBase instanceof InputPeripheral) {
				InputPeripheral tempBlock = (InputPeripheral)tempBase;
				tempBlock.interact();
			}
		}
	}
	
	@Override
	public void stopInteraction() {
		if (getBaseModuleBlock() != null) {
			Block tempBase = getBaseModuleBlock().getBlock();
			if (tempBase instanceof InputPeripheral) {
				InputPeripheral tempBlock = (InputPeripheral)tempBase;
				tempBlock.stopInteraction();
			}
		}
	}

	@Override
	public boolean updateConnection(World world, Pos pos) {
		Set<Pos> tempSeenPosSet = new HashSet<Pos>();
		List<Pos> tempPosList = new ArrayList<Pos>();
		tempPosList.add(pos);
		while (tempPosList.size() > 0) {
			List<Pos> tempPosList2 = new ArrayList<Pos>();
			int index = 0;
			while (index < tempPosList.size()) {
				Pos tempPos = tempPosList.get(index);
				if (!tempSeenPosSet.contains(tempPos)) {
					Block tempBlock = world.getBlock(tempPos);
					if (tempBlock instanceof BaseInputPeripheral) {
						BaseInputPeripheral tempBase = (BaseInputPeripheral)tempBlock;
						return setBaseModuleBlock(tempBase);
					}
					if (tempBlock instanceof ExtensionInputPeripheral) {
						int tempSide = 0;
						while (tempSide <= 3) {
							tempPosList2.add(World.getPosOnSide(tempPos, tempSide));
							tempSide += 1;
						}
					}
					tempSeenPosSet.add(tempPos);
				}
				index += 1;
			}
			tempPosList = tempPosList2;
		}
		return setBaseModuleBlock(null);
	}

}
