package logicland2.block;

import logicland2.Brushable;
import logicland2.Pos;
import logicland2.World;

public class ExtensionLogicModule extends LogicModule {
	
	@Override
	public Block copy() {
		Block output = new ExtensionLogicModule();
		populateCopy(output);
		return output;
	}

	@Override
	public Brushable getNextVariation() {
		return new OrLogicModule();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new AdditionLogicModule();
	}
	
	@Override
	public boolean updateConnection(World world, Pos pos) {
		Block tempBlock;
		tempBlock = world.getBlock(World.getPosOnSide(pos, 0));
		if (tempBlock instanceof LogicModule) {
			LogicModule tempLogicModule = (LogicModule)tempBlock;
			if (setBaseModuleBlock(tempLogicModule.getBaseModuleBlock())) {
				return true;
			}
		}
		tempBlock = world.getBlock(World.getPosOnSide(pos, 3));
		if (tempBlock instanceof LogicModule) {
			LogicModule tempLogicModule = (LogicModule)tempBlock;
			if (setBaseModuleBlock(tempLogicModule.getBaseModuleBlock())) {
				return true;
			}
		}
		return false;
	}
	
}
