package logicland2.block;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import logicland2.Brushable;
import logicland2.Pos;
import logicland2.World;

public class ExtensionOutputPeripheral extends OutputPeripheral {
	
	@Override
	public Block copy() {
		Block output = new ExtensionOutputPeripheral();
		populateCopy(output);
		return output;
	}

	@Override
	public Brushable getNextVariation() {
		return new SwitchInputPeripheral();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new LightOutputPeripheral();
	}
	
	@Override
	public boolean updateConnection(World world, Pos pos) {
		Set<Pos> tempSeenPosSet = new HashSet<Pos>();
		List<Pos> tempPosList = new ArrayList<Pos>();
		tempPosList.add(pos);
		while (tempPosList.size() > 0) {
			List<Pos> tempPosList2 = new ArrayList<Pos>();
			int index = 0;
			while (index < tempPosList.size()) {
				Pos tempPos = tempPosList.get(index);
				if (!tempSeenPosSet.contains(tempPos)) {
					Block tempBlock = world.getBlock(tempPos);
					if (tempBlock instanceof BaseOutputPeripheral) {
						BaseOutputPeripheral tempBase = (BaseOutputPeripheral)tempBlock;
						return setBaseModuleBlock(tempBase);
					}
					if (tempBlock instanceof ExtensionOutputPeripheral) {
						int tempSide = 0;
						while (tempSide <= 3) {
							tempPosList2.add(World.getPosOnSide(tempPos, tempSide));
							tempSide += 1;
						}
					}
					tempSeenPosSet.add(tempPos);
				}
				index += 1;
			}
			tempPosList = tempPosList2;
		}
		return setBaseModuleBlock(null);
	}
	
}
