package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class FlipFlopLogicModule extends BaseLogicModule {
	
	@Override
	public Block copy() {
		Block output = new FlipFlopLogicModule();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			int tempWhich;
			if (getModuleCore().getData()) {
				tempWhich = 145;
			} else {
				tempWhich = 144;
			}
			panel.drawSprite(graphics, tempPos, tempWhich);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new AdditionLogicModule();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new XorLogicModule();
	}
	
	@Override
	public void receiveUpdate(LogicInput block) {
		if (block instanceof WriteLogicInput && block.getState()) {
			int tempCount = getModuleCore().getActiveDataLogicInputCount();
			getModuleCore().setData(tempCount > 0);
		}
		if (block instanceof SetLogicInput && block.getState()) {
			getModuleCore().setData(true);
		}
		if (block instanceof ResetLogicInput && block.getState()) {
			getModuleCore().setData(false);
		}
		if (block instanceof ToggleLogicInput && block.getState()) {
			getModuleCore().setData(!getModuleCore().getData());
		}
	}
	
}
