package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class InvertLogicInput extends DataLogicInput {

	public InvertLogicInput() {
		super();
		setState(true);
	}
	
	@Override
	public Block copy() {
		Block output = new InvertLogicInput();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 181);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new SetLogicInput();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new BufferLogicInput();
	}
	
	@Override
	public void setStateBySignalValue(boolean value) {
		setState(!value);
	}
	
}
