package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class LightOutputPeripheral extends BaseOutputPeripheral {

	@Override
	public Block copy() {
		Block output = new LightOutputPeripheral();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 165);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new ExtensionOutputPeripheral();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new ExtensionInputPeripheral();
	}
	
	@Override
	public void receiveUpdate(LogicInput block) {
		if (block instanceof DataLogicInput) {
			getModuleCore().setData(block.getState());
		}
	}
	
}
