package logicland2.block;

import java.awt.Color;
import java.awt.Graphics;

import logicland2.CustomPanel;
import logicland2.Pos;
import logicland2.World;

public abstract class LogicModule extends ModuleBlock {

	private static Color color = new Color(0, 0, 255);
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		World tempWorld = panel.getWorld();
		Pos tempPos = pos.copy();
		tempPos.subtract(panel.getCameraPos());
		tempPos.scale(panel.getZoom());
		if (panel.getZoom() >= 8.0) {
			int tempWhich = 64;
			Pos tempPos2;
			Block tempBlock;
			tempPos2 = World.getPosOnSide(pos, 0);
			tempBlock = tempWorld.getBlock(tempPos2);
			if (!(tempBlock instanceof LogicModule) || !(this instanceof ExtensionLogicModule)) {
				tempWhich += 1;
			}
			tempPos2 = World.getPosOnSide(pos, 1);
			tempBlock = tempWorld.getBlock(tempPos2);
			if (!(tempBlock instanceof ExtensionLogicModule)) {
				tempWhich += 2;
			}
			tempPos2 = World.getPosOnSide(pos, 2);
			tempBlock = tempWorld.getBlock(tempPos2);
			if (!(tempBlock instanceof ExtensionLogicModule)) {
				tempWhich += 4;
			}
			tempPos2 = World.getPosOnSide(pos, 3);
			tempBlock = tempWorld.getBlock(tempPos2);
			if (!(tempBlock instanceof LogicModule) || !(this instanceof ExtensionLogicModule)) {
				tempWhich += 8;
			}
			panel.drawSprite(graphics, tempPos, tempWhich);
		} else {
			graphics.setColor(color);
			int tempSize = (int)(panel.getZoom());
			if (tempSize < 1) {
				tempSize = 1;
			}
			graphics.fillRect(tempPos.getX(), tempPos.getY(), tempSize, tempSize);
		}
	}

	@Override
	public boolean isWireConnectable() {
		return false;
	}

	@Override
	public boolean connectsOnSide(int side) {
		return false;
	}
	
}
