package logicland2.block;

import logicland2.Pos;
import logicland2.World;

public abstract class ModuleConnectableBlock extends Block {
	
	private BaseModuleBlock baseModuleBlock = null;
	
	@Override
	public void addEvent(World world, Pos inputPos) {
		world.propagateModuleConnectionUpdates(inputPos);
		int tempSide = 0;
		while (tempSide <= 3) {
			world.propagateModuleConnectionUpdates(World.getPosOnSide(inputPos, tempSide));
			tempSide += 1;
		}
		super.addEvent(world, inputPos);
	}
	
	@Override
	public void removeEvent(World world, Pos pos) {
		if (baseModuleBlock != null) {
			baseModuleBlock.getModuleCore().removeBlock(this);
		}
		int tempSide = 0;
		while (tempSide <= 3) {
			world.propagateModuleConnectionUpdates(World.getPosOnSide(pos, tempSide));
			tempSide += 1;
		}
		super.removeEvent(world, pos);
	}
	
	public BaseModuleBlock getBaseModuleBlock() {
		return baseModuleBlock;
	}
	
	public boolean setBaseModuleBlock(BaseModuleBlock block) {
		if (block == baseModuleBlock) {
			return false;
		}
		if (baseModuleBlock != null) {
			baseModuleBlock.getModuleCore().removeBlock(this);
		}
		baseModuleBlock = block;
		if (baseModuleBlock != null) {
			baseModuleBlock.getModuleCore().addBlock(this);
		}
		return true;
	}
	
	public abstract boolean updateConnection(World world, Pos pos);
	
}
