package logicland2.block;

import java.awt.Color;
import java.awt.Graphics;

import logicland2.CustomPanel;
import logicland2.Pos;
import logicland2.World;

public abstract class OutputPeripheral extends ModuleBlock {

	private static Color activeColor = new Color(255, 255, 0);
	private static Color inactiveColor = new Color(96, 96, 0);
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		World tempWorld = panel.getWorld();
		boolean tempState;
		if (getBaseModuleBlock() == null) {
			tempState = false;
		} else {
			tempState = getBaseModuleBlock().getModuleCore().getData();
		}
		Pos tempPos = pos.copy();
		tempPos.subtract(panel.getCameraPos());
		tempPos.scale(panel.getZoom());
		if (panel.getZoom() >= 8.0) {
			int tempWhich = 112;
			if (tempState) {
				tempWhich += 16;
			}
			int tempOffset = 1;
			int tempSide = 0;
			while (tempSide <= 3) {
				Pos tempPos2 = World.getPosOnSide(pos, tempSide);
				Block tempBlock = tempWorld.getBlock(tempPos2);
				if (!(tempBlock instanceof OutputPeripheral)) {
					tempWhich += tempOffset;
				}
				tempOffset *= 2;
				tempSide += 1;
			}
			panel.drawSprite(graphics, tempPos, tempWhich);
		} else {
			if (tempState) {
				graphics.setColor(activeColor);
			} else {
				graphics.setColor(inactiveColor);
			}
			int tempSize = (int)(panel.getZoom());
			if (tempSize < 1) {
				tempSize = 1;
			}
			graphics.fillRect(tempPos.getX(), tempPos.getY(), tempSize, tempSize);
		}
	}

	@Override
	public boolean isWireConnectable() {
		return false;
	}

	@Override
	public boolean connectsOnSide(int side) {
		return false;
	}
	
}
