package logicland2.block;

import java.awt.Graphics;

import logicland2.Brushable;
import logicland2.CustomPanel;
import logicland2.Pos;

public class WriteLogicInput extends LogicInput {

	@Override
	public Block copy() {
		Block output = new WriteLogicInput();
		populateCopy(output);
		return output;
	}
	
	@Override
	public void draw(CustomPanel panel, Graphics graphics, Pos pos) {
		super.draw(panel, graphics, pos);
		if (panel.getZoom() >= 8.0) {
			Pos tempPos = pos.copy();
			tempPos.subtract(panel.getCameraPos());
			tempPos.scale(panel.getZoom());
			panel.drawSprite(graphics, tempPos, 176);
		}
	}

	@Override
	public Brushable getNextVariation() {
		return new ToggleLogicInput();
	}

	@Override
	public Brushable getPreviousVariation() {
		return new ResetLogicInput();
	}
	
}
